'use client'
import React from 'react'
import PropTypes from 'prop-types'
import Link from 'next/link'

const Breadcrumb = ({ showBreadcrumb, title, content, contentTwo, contentThree, contentFour, allgames }) => {
  return (
    <React.Fragment>
      {showBreadcrumb && (
        <div className='overflow-hidden my-4  md:my-6'>
          <div className='flex flex-wrap'>
            <div className=' flex justify-center items-center flex-col relative container'>
              <div className=''>
                <h1 className='mb-3 md:mb-5 text-2xl md:text-3xl lg:text-4xl xl:text-5xl font-extrabold leading-snug tracking-normal capitalize text-text-color max-767:text-inherit'>
                  {title}
                </h1>
              </div>
              <div className='breadcrumb__inner'>
                <ul className='py-2 px-0 bg-transparent mb-0 flex items-center flex-wrap sm:flex-nowrap justify-center'>
                  <li>
                    <Link
                      className='text-primary-color relative block font-semibold text-base sm:text-lg md:text-xl lg:text-2xl hover:text-text-color transition-colors'
                      href={'/'}
                    >
                      {content}
                    </Link>
                  </li>
                  {allgames && (
                    <li className="before:mx-1 sm:before:mx-2 md:before:mx-3 before:content-['/'] before:text-[calc(0.875rem+0.125vw)] sm:before:text-[calc(1rem+0.125vw)] md:before:text-[calc(1.125rem+0.125vw)] lg:before:text-[calc(1.25rem+0.125vw)] before:text-text-color">
                      <Link className='text-text-color font-semibold text-base sm:text-lg md:text-xl lg:text-2xl transition-colors' href={'/quiz-play'}>
                        {allgames}
                      </Link>
                    </li>
                  )}
                  {contentTwo && (
                    <li className="text-text-color font-semibold text-base sm:text-lg md:text-xl lg:text-2xl before:mx-1 sm:before:mx-2 md:before:mx-3 before:content-['/'] before:text-[calc(0.875rem+0.125vw)] sm:before:text-[calc(1rem+0.125vw)] md:before:text-[calc(1.125rem+0.125vw)] lg:before:text-[calc(1.25rem+0.125vw)] flex items-center">
                      {contentTwo}
                    </li>
                  )}
                  {contentThree && (
                    <li className="text-text-color font-semibold text-base sm:text-lg md:text-xl lg:text-2xl before:mx-1 sm:before:mx-2 md:before:mx-3 before:content-['/'] before:text-[calc(0.875rem+0.125vw)] sm:before:text-[calc(1rem+0.125vw)] md:before:text-[calc(1.125rem+0.125vw)] lg:before:text-[calc(1.25rem+0.125vw)] flex items-center">
                      {contentThree}
                    </li>
                  )}
                  {contentFour && (
                    <li className="text-text-color font-semibold text-base sm:text-lg md:text-xl lg:text-2xl before:mx-1 sm:before:mx-2 md:before:mx-3 before:content-['/'] before:text-[calc(0.875rem+0.125vw)] sm:before:text-[calc(1rem+0.125vw)] md:before:text-[calc(1.125rem+0.125vw)] lg:before:text-[calc(1.25rem+0.125vw)] flex items-center">
                      {contentFour}
                    </li>
                  )}
                </ul>
              </div>
            </div>
          </div>
        </div>
      )}
    </React.Fragment>
  )
}

Breadcrumb.propTypes = {
  title: PropTypes.string,
  content: PropTypes.string,
  contentTwo: PropTypes.string,
  contentThree: PropTypes.string
}

export default Breadcrumb
