"use client";
import { withTranslation } from "react-i18next";
import { truncate } from "@/utils";
import LineFooterForTitle from "@/components/Common/LineFooterForTitle";

const Features = (props) => {
  const data = [
    {
      id: "1",
      image: props?.homeSettings?.section2_image1,
      title: props?.homeSettings?.section2_title1,
      desc: props?.homeSettings?.section2_desc1,
    },
    {
      id: "2",
      image: props?.homeSettings?.section2_image2,
      title: props?.homeSettings?.section2_title2,
      desc: props?.homeSettings?.section2_desc2,
    },
    {
      id: "3",
      image: props?.homeSettings?.section2_image3,
      title: props?.homeSettings?.section2_title3,
      desc: props?.homeSettings?.section2_desc3,
    },
    {
      id: "4",
      image: props?.homeSettings?.section2_image4,
      title: props?.homeSettings?.section2_title4,
      desc: props?.homeSettings?.section2_desc4,
    },
  ];
  return (
    <>
      {!props.isLoading ? (
        <section className="commonMT">
          <div className="container">
            <div className="flex flex-wrap">
              <div className="relative w-max mx-auto lg:mb-5">
                <h2 className="text-center text-xl md:text-2xl lg:text-3xl font-semibold">
                  {props?.homeSettings?.section2_heading}
                </h2>
                <LineFooterForTitle />
              </div>
            </div>
            <div className="mt-4 md:mt-8 lg:mt-10">
              <div className="flex flex-wrap">
                {data &&
                  data.map((elem, index) => (
                    <div className="w-full md:w-1/2 group" key={index}>
                      <div className="flex flex-col items-center md:flex-row gap-3 lg:gap-6 relative mb-4 md:mb-6 p-4 lg:p-8 border border-white bg-[#0900290f] rounded-2xl m-3">
                        <div className="w-20 lg:w-24 flex-shrink-0 mx-auto md:mx-0">
                          <img
                            className="w-full h-20 lg:h-24 object-contain group-hover:animate-zoominout"
                            src={elem?.image}
                            alt="line"
                          />
                        </div>

                        <div className="flex-grow text-center md:text-left">
                          <h3 className="text-text-color text-lg md:text-xl lg:text-2xl font-medium mb-2">
                            {truncate(elem?.title, 19)}
                          </h3>
                          <p className="text-[15px] md:text-sm lg:text-base font-normal">
                            {truncate(elem?.desc, 115)}
                          </p>
                        </div>
                      </div>
                    </div>
                  ))}
              </div>
            </div>
          </div>
        </section>
      ) : null}
    </>
  );
};

export default withTranslation()(Features);
