import React from 'react'
import excla from '@/assets/images/exclamation.svg'
import { FiChevronRight } from 'react-icons/fi'
import { t } from '@/utils'
import c1 from '@/assets/images/c1.svg'

const CategoriesComponent = ({ category, handleChangeCategory }) => {
  //truncate text
  const truncate = txtlength => (txtlength?.length > 17 ? `${txtlength.substring(0, 17)}...` : txtlength)

  return (
    <>

      <div className='flex justify-center w-full items-center mt-4 mb-6 gap-[10px]'>
        <div className='bg-[#a6a5a7] p-[1px] w-full opacity-[24%] h-[1px] hidden md:block'></div>
        <h5 className='w-full text-lg font-semibold text-center max-[1199px]:flex max-[1199px]:p-0 max-[1199px]:w-full max-[1199px]:text-center max-[1199px]:justify-center'>
          {t('Categories')}
        </h5>
        <div className='bg-[#a6a5a7] p-[1px] w-full opacity-[24%] h-[1px] hidden md:block'></div>
        <div></div>
      </div>
      {category.all ? (
        <div className='grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3 gap-7'>
          {category.all.map((data, key) => {
            const imageToShow = data?.has_unlocked === '0' && data?.is_premium === '1'
            return (
              <div className='' key={key}>
                {/* <Link href={`/quiz-zone/${data.slug}`} > */}
                <li className='flex hover:cursor-pointer group:' onClick={e => handleChangeCategory(data)}>
                  <div
                    className={`group w-full flex rounded-[15px] items-start flex-col px-[30px] pb-5 bg-[#0900290f] relative transition-all duration-300 ease-in-out overflow-hidden
                        before:absolute before:top-0 before:left-0 before:bg-primary-color before:bg-[0%_0%] before:bg-no-repeat before:bg-clip-padding   before:opacity-10
                         before:blur-[25px] before:w-[25%] before:h-full before:transition-[left] before:duration-2000 hover:before:left-[50%] hover:before:w-[50%] 
                        ${category.selected && category.selected.id === data?.id ? 'active-one' : 'unactive-one'
                      }`}
                  >
                    <div className='flex justify-start items-center gap-4 w-full h-[80px] border-b-[0.5px] border-[#d3d3d3]'>
                      <span className='ml-[10px] flex justify-center items-center z-1 text-white'>
                        <img
                          className='w-[45px] h-[45px] object-contain max-w-[100%] max-h-[100%] rounded-[5px]'
                          src={data?.image ? data?.image : `${excla.src}`}
                          alt='image'
                        />
                      </span>
                      <div className='flex justify-center items-baseline flex-col'>
                        <p className='text-base leading-[18px] font-bold text-text-color text-start mb-2 '>
                          {truncate(data?.category_name)}
                        </p>
                        {data?.no_of !== '0' && data?.no_of !== '' ? (
                          <p className='text-[13px] font-normal leading-4 text-text-color mb-[-5px]'>
                            {t('SubCategories')} : {data?.no_of}
                          </p>
                        ) : null}
                      </div>
                      <span className='absolute rtl:left-[22px]  ltr:right-[22px] top-[22px] text-text-color text-xl hidden transition-all duration-300 ease-in-out group-hover:block group-hover:transition-all group-hover:duration-2000 group-hover:ease-in-out'>
                        <FiChevronRight className='rtl:rotate-180'/>
                      </span>
                    </div>
                    <div className='mt-4 flex items-center w-full justify-between flex-wrap'>
                      <div className="flex gap-5">
                        {data?.maxlevel !== '0' && (
                          <span className='text-sm font-normal leading-[17px] text-text-color'>
                            {t('total') + ' ' + t('level') + ': '}
                            {data?.maxlevel}
                          </span>
                        )}
                        <span className='text-sm font-normal leading-4 text-text-color'>
                          {data?.no_of_que <= 1 ? t('Question') : t('questions')} : {data?.no_of_que}
                        </span>
                      </div>
                      {imageToShow ? <img className='absolute rtl:left-4 ltr:right-4' src={c1.src} alt='premium' width={30} height={30} /> : ''}
                    </div>
                  </div>
                </li>
                {/* </Link> */}
              </div>
            )
          })}
        </div>
      ) : (
        <div className='text-center'>
          <p className='text-dark'>{t('no_cat_data_found')}</p>
        </div>
      )}
    </>
  )
}

export default CategoriesComponent
