'use client'
import Breadcrumb from '@/components/Common/Breadcrumb'
import { withTranslation } from 'react-i18next'
import { selectResultTempData, selecttempdata } from '@/store/reducers/tempDataSlice'
import { useSelector } from 'react-redux'
import dynamic from 'next/dynamic'
const Layout = dynamic(() => import('@/components/Layout/Layout'), { ssr: false })
import { t } from '@/utils'
import { lazy, Suspense, useEffect } from 'react'
import ShowScoreSkeleton from '@/components/view/common/ShowScoreSkeleton'
import { groupbattledata } from '@/store/reducers/groupbattleSlice'
import { sysConfigdata } from '@/store/reducers/settingsSlice'
import { RandomQuestionsApi } from '@/store/actions/campaign'
import { deleteDoc, doc, getFirestore } from 'firebase/firestore'
import toast from 'react-hot-toast'
const GroupBattleScore = lazy(() => import('@/components/Quiz/GroupBattle/GroupBattleScore'))
const GroupPlay = () => {
  const showScore = useSelector(selectResultTempData)

  let getData = useSelector(selecttempdata)
    const groupBattledata = useSelector(groupbattledata)
    const systemconfig = useSelector(sysConfigdata)
    let battleRoomDocumentId = groupBattledata.roomID
    const db = getFirestore();
    const deleteBattleRoom = async () => {
        RandomQuestionsApi(
            battleRoomDocumentId,
            systemconfig.battle_mode_group_category == "1" ? getData.category_id : 0,
            1,
            () => { },
            () => { }
        );
        try {
            await deleteDoc(doc(db, "multiUserBattleRoom", battleRoomDocumentId));
        } catch (error) {
            toast.error(error);
        }
    };
    useEffect(() => {
        deleteBattleRoom()
    }, []);

  return (
    <Layout>
      <Breadcrumb title={t('Group Battle')} content={t('')} contentTwo='' />
      <div className='container mb-14'>
        <>
          <Suspense fallback={<ShowScoreSkeleton />}>
            <GroupBattleScore totalQuestions={showScore.totalQuestions} />
          </Suspense>
        </>
      </div>
    </Layout>
  )
}
export default withTranslation()(GroupPlay)
