"use client";
import React from "react";
import { withTranslation } from "react-i18next";
import Breadcrumb from "@/components/Common/Breadcrumb";
import dynamic from "next/dynamic";
import { useSelector } from "react-redux";
import Meta from "@/components/SEO/Meta";
import maintainenceimg from "@/assets/images/maintenance.svg";
import ThemeSvg from "@/components/ThemeSvg/ThemeSvg";
const Layout = dynamic(() => import("@/components/Layout/Layout"), {
  ssr: false,
});
import { t } from "@/utils";

const Maintainance = () => {
  return (
    <>
      <Meta />
      <Layout>
        <Breadcrumb title={t("maintainance")} content="" contentTwo="" />
        <div className="Maintainance">
          <div className="container mb-14">
            <div className="row">
              <div className="col-md-8 col-12 mx-auto">
                <div className="morphisam">
                  <div className="left_image">
                    <ThemeSvg
                      src={maintainenceimg.src}
                      className="maintain_img"
                      width="100%"
                      height="100%"
                      alt="Maintenance"
                      colorMap={{
                        "#e03c75": "var(--primary-color)",
                        "#551948": "var(--secondary-color)",
                        "#3f1239": "var(--secondary-color)",
                        "#7b2167": "var(--secondary-color)",
                        "#ac5e9f": "var(--primary-color)",
                      }}
                    />
                  </div>
                  <div className="right_text">
                    <p>{t("sry_for_maintenance")}</p>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </Layout>
    </>
  );
};

export default withTranslation()(Maintainance);
