"use client"
import { t } from "@/utils/index";
import dynamic from 'next/dynamic'
import { useRouter } from 'next/router'
import React, { Suspense } from 'react'
import { useSelector } from 'react-redux'
import Breadcrumb from '@/components/Common/Breadcrumb'
import QuestionSkeleton from '@/components/view/common/QuestionSkeleton'
const Layout = dynamic(() => import('@/components/Layout/Layout'), { ssr: false })
// const ReviewAnswer = dynamic(() => import('@/components/Common/ReviewAnswer'), { ssr: false })

import MultiMatchReviewAnswer from "@/components/Quiz/MultiMatch/MultiMatchReviewAnswer";
import { questionsData } from "@/store/reducers/tempDataSlice";

const Index = () => {

  const navigate = useRouter()

  const questions = useSelector(questionsData)


  const handleReviewAnswerBack = () => {
    navigate.push("/multi-match-questions/result")
  }

  return (
    <Layout>
      <Breadcrumb title={t('multi_match')} content="" contentTwo="" />
      <div className='container'>
        <Suspense fallback={<QuestionSkeleton />}>
          <MultiMatchReviewAnswer
            reportquestions={true}
            reviewlevel={false}
            questions={questions}
            showLevel={false}
            latex={false}
            goBack={handleReviewAnswerBack}
            showBookmark={false}
            isMulti={true}
          />
        </Suspense>
      </div>
    </Layout >

  )
}

export default Index
























































// import ProgressBar from 'react-bootstrap/ProgressBar';
// import { useSelector } from 'react-redux';
// import { sysConfigdata } from 'src/store/reducers/settingsSlice';
// import { RenderHtmlContent, imgError, t, useOverflowRefs } from "src/utils"
// import { DragDropContext, Droppable, Draggable } from '@hello-pangea/dnd';
// import { useEffect, useState } from 'react';
// import rightTickIcon from 'src/assets/images/check-circle-score-screen.svg'
// import crossIcon from 'src/assets/images/x-circle-score-screen.svg'
// import { RiArrowLeftDoubleLine, RiArrowRightDoubleLine } from "react-icons/ri";

// const reviewAnswer = () => {
//   const [currentQuestion, setCurrentQuestion] = useState(0);
//   const [disablePrev, setDisablePrev] = useState(true);
//   const [disableNext, setDisableNext] = useState(false);
//   const [totalOptions, setTotalOptions] = useState()
//   const [questions, setQuestions] = useState([
//     {
//       "id": "3401",
//       "category": "81",
//       "subcategory": "73",
//       "language_id": "14",
//       "image": "",
//       "question": "22\r\n",
//       "question_type": "2",
//       "optiona": "11",
//       "optionb": "22",
//       "optionc": "qqq",
//       "optiond": "qqq",
//       "optione": "sss",
//       "answer": ['a', 'b', 'c'],
//       "arrange": ['a', 'b', 'c', 'd', 'e'],
//       "level": "1",
//       "note": "",
//       "category_slug": "test-latex",
//       "subcategory_slug": "premium-1",
//       "isBookmarked": false,
//       "selected_answer": "",
//       "isAnswered": false
//     },
//     {
//       "id": "3421",
//       "category": "81",
//       "subcategory": "73",
//       "language_id": "14",
//       "image": "",
//       "question": "11\r\n",
//       "question_type": "2",
//       "optiona": "22",
//       "optionb": "111",
//       "optionc": "www",
//       "optiond": "eee",
//       "optione": "",
//       "answer": ['a'],
//       "arrange": ['a', 'b', 'c', 'd'],
//       "level": "1",
//       "note": "",
//       "category_slug": "test-latex",
//       "subcategory_slug": "premium-1",
//       "isBookmarked": false,
//       "selected_answer": "",
//       "isAnswered": false
//     },
//     {
//       "id": "3400",
//       "category": "81",
//       "subcategory": "73",
//       "language_id": "14",
//       "image": "",
//       "question": "11\r\n",
//       "question_type": "2",
//       "optiona": "11",
//       "optionb": "22",
//       "optionc": "33",
//       "optiond": "44",
//       "optione": "55",
//       "answer": ['a', 'b'],
//       "arrange": ['a', 'b', 'c', 'd', 'e'],
//       "level": "1",
//       "note": "",
//       "category_slug": "test-latex",
//       "subcategory_slug": "premium-1",
//       "isBookmarked": false,
//       "selected_answer": "",
//       "isAnswered": false
//     },
//     {
//       "id": "3402",
//       "category": "81",
//       "subcategory": "73",
//       "language_id": "14",
//       "image": "",
//       "question": "Edebiyat; hava gibi, su gibi, g&uuml;neş gibi, toprak gibi vazge&ccedil;ilmezdi. Onunla yatılıp onunla kalkılıyordu ve yaratıcı g&uuml;c&uuml;n&uuml;n sonsuzluğuna, edebiyatın insanı insan yapma b&uuml;y&uuml;s&uuml;ne İnanılıyordu. Toplumun yozlaşmaya ve her şeyin parayla &ouml;l&ccedil;&uuml;ld&uuml;ğ&uuml;, bilgi ve k&uuml;lt&uuml;re duyulan saygının, kredi kartlarına, g&ouml;rselliğe y&ouml;nelmeye başladığı yıllarda, edebiyat “Bir işlevi yok.” d&uuml;ş&uuml;ncesiyle gazetelerden kovuldu. Edebiyat kovulunca da gazeteler &ccedil;irkinleşti, gazetelerle birlikte dil de espri de d&uuml;ş&uuml;nce de sığlaşıp y&uuml;celiğini yitirdi. Bu par&ccedil;aya dayanılarak, edebiyatla ilgili olarak aşağıdakilerden hangisine varılamaz?\r\n",
//       "question_type": "2",
//       "optiona": "asdasd",
//       "optionb": "asdasd",
//       "optionc": "aaaa",
//       "optiond": "ddddd",
//       "optione": "",
//       "answer": ['b', 'd'],
//       "arrange": ['d', 'b', 'c', 'a'],
//       "level": "1",
//       "note": "asasd\r\n",
//       "category_slug": "test-latex",
//       "subcategory_slug": "premium-1",
//       "isBookmarked": false,
//       "selected_answer": "",
//       "isAnswered": false
//     }
//   ])


//   const defaultOptions = [
//     { option: 'optiona', opt: 'a' },
//     { option: 'optionb', opt: 'b' },
//     { option: 'optionc', opt: 'c' },
//     { option: 'optiond', opt: 'd' },
//     { option: 'optione', opt: 'e' },
//   ];
//   const [options, setOptions] = useState(defaultOptions);

//   let isSelectAns = true

//   const handleDragEnd = (result) => {
//     if (!result.destination) return;
//     let totalOpt = options.filter((option) => questions[currentQuestion][option.option] !== '');

//     const items = Array.from(totalOpt);

//     const [reorderedItem] = items.splice(result.source.index, 1);
//     items.splice(result.destination.index, 0, reorderedItem);

//     setOptions(items);
//     let selectSequence = items.map((item) => item.opt)
//     arrangedOptions(selectSequence)
//   };

//   const previousQuestion = () => {
//     const prevQuestion = currentQuestion - 1;
//     if (prevQuestion >= 0) {
//       if (prevQuestion > 0) {
//         setDisablePrev(false);
//       } else {
//         setDisablePrev(true);
//       }
//       setDisableNext(false);
//       setCurrentQuestion(prevQuestion);
//     }
//   };

//   const nextQuestion = () => {
//     const nextQuestion = currentQuestion + 1;
//     if (nextQuestion < questions?.length) {
//       if (nextQuestion + 1 === questions?.length) {
//         setDisableNext(true);
//       } else {
//         setDisableNext(false);
//       }
//       setDisablePrev(false);
//       setCurrentQuestion(nextQuestion);
//     }
//   };


//   useEffect(() => {
//     let totalOpt = options.filter((option) => questions[currentQuestion][option.option]).length

//     setTotalOptions(totalOpt)
//   }, [])
//   useEffect(() => {
//     setOptions(defaultOptions);
//   }, [currentQuestion]);

//   const setAnswerStatusClass = (option) => {
//     // let decryptedAnswer = decryptAnswer(questions[currentQuestion]?.answer, userData?.data?.firebase_id);
//     // if (decryptedAnswer === option) {
//     //   return "bg-success";
//     // } else if (questions[currentQuestion].selected_answer === option) {
//     //   return "bg-danger";
//     // }
//   };
//   const rightWrongIcon = (option) => {

//     if (questions[currentQuestion].answer.includes(option) && questions[currentQuestion].selected_answer.includes(option)) {
//       return <img src={rightTickIcon.src} className='right_wrong_ans' alt="" />
//     } else if (!questions[currentQuestion].answer.includes(option) && questions[currentQuestion].selected_answer.includes(option)) {
//       return <img src={crossIcon.src} className='right_wrong_ans' alt="" />
//     } else if (questions[currentQuestion].answer.includes(option) && !questions[currentQuestion].selected_answer.includes(option)) {
//       return <img src={crossIcon.src} className='right_wrong_ans' alt="" />
//     } else if (!questions[currentQuestion].answer.includes(option) && !questions[currentQuestion].selected_answer.includes(option)) {
//       return false
//     }

//   }
//   const goBack = ()=>{

//   }
//   return (
//     <>
//       <div className='row morphisam mb-4'>
//         <div className='col-12 col-lg-8 content__text'>

//           <p className='question-text'>{questions[currentQuestion]?.question}</p>

//           {questions[currentQuestion]?.image ? (
//             <div className='col-12 col-lg-8  imagedash'>
//               <img src={questions[currentQuestion].image} onError={imgError} alt='' />
//             </div>
//           ) : (
//             ''
//           )}

//         </div>



//         {/* options */}
//         <div className='col-12 col-lg-4 '>
//           <div className='row optionsWrapper'>
//             {isSelectAns ?
//               options.map((option, index) => {
//                 // Check if the option exists
//                 if (questions[currentQuestion][option.option]) {
//                   return (
//                     <div key={index} className="col-12 col-md-6 col-lg-12">
//                       <div className="inner__questions">
//                         <button
//                           ref={option.ref}
//                           className={`btn button__ui w-100 ${setAnswerStatusClass(option.opt)} align-items-start justify-content-between`}
//                           disabled={true}
//                         >
//                           <div className="row">
//                             <div className="col optionBtn">
//                               <span className="optionIndex">
//                                 {t(option.opt)}&nbsp;
//                               </span>
//                               {questions[currentQuestion][option.option]}
//                             </div>
//                           </div>
//                           {rightWrongIcon(option.opt) && <div className='right_wrong_ans_icon'>
//                             {rightWrongIcon(option.opt)}
//                           </div>}
//                         </button>
//                       </div>
//                     </div>
//                   );
//                 } else {
//                   return null; // Skip rendering if the option doesn't exist
//                 }
//               }) : <div className='mb-4'>
//                 {/* <DragDropContext onDragEnd={handleDragEnd}>
//                   <Droppable droppableId="options">
//                     {(provided) => (
//                       <div
//                         {...provided.droppableProps}
//                         ref={provided.innerRef}
//                       >
//                         {options.map((option, index) => {
//                           const optionContent = questions[currentQuestion]?.[option.option];

//                           if (!optionContent) {
//                             return null;
//                           }

//                           return (
//                             <Draggable
//                               key={option.opt}
//                               draggableId={option.opt || `option-${index}`}
//                               index={index}
//                             >
//                               {(provided) => (
//                                 <div
//                                   ref={provided.innerRef}
//                                   {...provided.draggableProps}
//                                   {...provided.dragHandleProps}
//                                   className="optionBtn"
//                                   disabled={isClickedAnswer}
//                                 >
//                                   <div key={index} className="col-12 col-md-6 col-lg-12">
//                                     <div className="inner__questions">
//                                       <div
//                                         ref={option.ref}
//                                         className={`p-4 rounded-lg ${setAnswerStatusClass(option.opt)} align-items-start justify-content-between`}
//                                         onClick={() => handleAnswerOptionClick(option.opt)}
//                                         disabled={isClickedAnswer}
//                                       >
//                                         <div className="row">
//                                           <div className="col optionBtn">
//                                             <span className="optionIndex">
//                                               {t(option.opt)}&nbsp;
//                                             </span>
//                                             {questions[currentQuestion][option.option]}
//                                           </div>
//                                         </div>
//                                       </div>
//                                     </div>
//                                   </div>
//                                 </div>
//                               )}
//                             </Draggable>
//                           );
//                         })}
//                         {provided.placeholder}
//                       </div>
//                     )}
//                   </Droppable>
//                 </DragDropContext> */}
//               </div>
//             }

//           </div>
//         </div>
//         <div><span>correct answer is,{questions[currentQuestion].arrange}</span>
//         </div>
//       </div>

//       <div className="dashoptions reviewDashoption">
//         <div className="fifty__fifty">
//           <button className="btn btn-primary" onClick={previousQuestion} disabled={disablePrev}>
//             <RiArrowLeftDoubleLine size={25} />
//           </button>
//         </div>
//         <div className="resettimer">
//           <button className="btn btn-primary" onClick={goBack}>
//             {t("back")}
//           </button>
//         </div>
//         <div className="skip__questions">
//           <button className="btn btn-primary" onClick={nextQuestion} disabled={disableNext}>
//             <RiArrowRightDoubleLine size={25} />
//           </button>
//         </div>
//       </div>
//       <div className="text-center review-answer-data">
//         <small className="review-latext-note">
//           {questions[currentQuestion]?.note ?
//             <><span class="text-nowrap">{t("note")} :- &nbsp; </span>{systemconfig.latex_mode === "1" ? <p><RenderHtmlContent htmlContent={questions[currentQuestion]?.note} /></p> : <p dangerouslySetInnerHTML={{ __html: questions[currentQuestion]?.note }}></p>}</>
//             :
//             ""
//           }
//         </small>
//       </div>
//     </>
//   )
// }

// export default reviewAnswer