'use client'
import React, { Suspense, useEffect, useState } from 'react'
import Breadcrumb from '@/components/Common/Breadcrumb'
import toast from 'react-hot-toast'
import { withTranslation } from 'react-i18next'
import { useDispatch, useSelector } from 'react-redux'
import { sysConfigdata } from '@/store/reducers/settingsSlice'
import { questionsData, resultTempDataSuccess, selecttempdata } from '@/store/reducers/tempDataSlice'
import { useRouter } from 'next/router'
import { groupbattledata } from '@/store/reducers/groupbattleSlice'
import dynamic from 'next/dynamic'
const Layout = dynamic(() => import('@/components/Layout/Layout'), { ssr: false })
import { t } from '@/utils'
import QuestionSkeleton from '@/components/view/common/QuestionSkeleton'
const PlaywithFriendBattlequestions = dynamic(
  () => import('@/components/Quiz/RandomBattle/PlaywithFriendBattlequestions'),
  {
    ssr: false
  }
)

const RandomPlay = () => {
  const navigate = useRouter()

  let getData = useSelector(selecttempdata)

  const dispatch = useDispatch()

  const groupBattledata = useSelector(groupbattledata)

  let user2uid = groupBattledata?.user2uid

  const [questions, setQuestions] = useState([{ id: '', isBookmarked: false }])

  const systemconfig = useSelector(sysConfigdata)

  const TIMER_SECONDS = Number(systemconfig?.battle_mode_one_in_seconds)

  const questionsdata = useSelector(questionsData)

  const onQuestionEnd = async (coins, quizScore) => {
    const tempData = {
      totalQuestions: questions?.length,
      coins: user2uid !== '000' ? coins : null, //this condition is only for bot play
      quizScore: quizScore
    }

    // Dispatch the action with the data
    dispatch(resultTempDataSuccess(tempData))
    await navigate.push('/random-battle/result')
  }

  return (
    <Layout>
      <Breadcrumb title={t('1 v/s 1 Battle')} content='' contentTwo='' />
      <div className='container mb-14'>
        <>
          <Suspense fallback={<QuestionSkeleton />}>
            <PlaywithFriendBattlequestions
              questions={questionsdata}
              timerSeconds={TIMER_SECONDS}
              onQuestionEnd={onQuestionEnd}
              showQuestions={true}
            />
          </Suspense>``
        </>
      </div>
    </Layout>
  )
}
export default withTranslation()(RandomPlay)
